Draft PathArray/cs: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 113: Line 113:


{{Emphasis|Editor:}} thank you to user DeepSOIC for this explanation.
{{Emphasis|Editor:}} thank you to user DeepSOIC for this explanation.

==Additional alignment modes and options introduced in v0.19==

'''Original''' mode (the default) is the historic alignment mode as in version 0.18.
It is not really the Frenet alignment. Original mode uses the normal parameter
from Draft.getNormal (or the default) as a constant - it does not calculate
curve normal. X follows the curve tangent, Y is the normal parameter, Z is
X.Cross(Y).

'''Tangent''' mode is similar to '''Original''', but includes a rotation to align the
Base object's X to the TangentVector before placing copies. After the
rotation, Tangent behaves the same as Original. In previous versions this
rotation would be performed manually before invoking PathArray.

'''Frenet''' mode orients the copies to a coordinate system along the path. X is
tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not
be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this
option is applied, the normal parameter from Draft.getNormal is ignored. X
follows the curve tangent, Z is the VerticalVector property and Y is
X.Cross(Z).

Version 18 cycle chain - Original mode
[[Image:patharray_cycleChain.png|600px|left|Align false]]
{{clear}}

Railway cross ties (sleepers) - Tangent mode + ForceVertical
[[Image:patharray_railwayTies.png|600px|left|Align false]]
{{clear}}

Frenet Mode
[[Image:patharray_FrenetMode.png|600px|left|Align false]]
{{clear}}



{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

Revision as of 20:41, 22 May 2020

Kreslení TrasovéPole

Umístění Menu
Draft → PathArray
Pracovní stoly
Kreslení, Architektura
Výchozí zástupce
Nikdo
Představen ve verzi
-
Viz také
Draft Array

Popis

Nástroj TrasovéPole umístí vybraný tvar na vybranou trasu. Trasa může být drát nebo jedna nebo více hran. Tvary na trase mohou být volitelně zarovnány podle trasy. Podle potřeby může být specifikován Vektor pro posunutí tvaru tak, že těžiště tvaru bude na trase. Pokud není vybrán žádný objekt, budete vyzváni k jeho výběru.

The PathArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies at specified points use Draft PointArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Object arranged along a path

Použití

  1. Vyberte objekt tvaru, který chcete kopírovat.
  2. Vyberte objekt trasy, po které chcete tvar kopírovat -nebo-
  3. Vyberte nějaké hrany pro určení trasy.
  4. Stiskněte tlačítko Kreslení TrasovéPole.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Volby

  • Pole začne s kopiemi tvaru, které nejsou zarovnány podle trasy ani defaultně posunuty na novou pozici. Ve vlastnostech můžete měnit počet, zarovnání a/nebo vektor posunutí.

Vlastnosti

  • ÚdajeBase: Objekt tvaru
  • ÚdajePathObj: Objekt trasy
  • ÚdajePathSubs: Subelementy(hrany) objektu trasy, které budou použity jako trasa
  • ÚdajeCount: Počet kopií tvaru
  • ÚdajeXlate: Vektor posunutí
  • ÚdajeAlign: Hodnota True pro zarovnání tvarů podle trasy, False pro ponechání tvarů podle jejich původní orientace.

Skriptování

Nástroj TrasovéPole může být využit v makrech a z konzoly Pythonu použitím následující funkce:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Rozloží požadovaný počet (count) kopií objektu shapeobject podél trasy pathobject nebo subobject (vybrané hrany) pathobjectu. Volitelně posune každou kopii ve směru a vzdálenosti podle FreeCAD.Vectoru pro nastavení rozdílu mezi středem tvaru a referenčním bodem tvaru. Volitelně zarovná baseobject tangenciálně/normálně/binormálně k trase.

Příklad:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technical explanation for the Align property

When ÚdajeAlign is false, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false
Align false

Object arranged along a closed path in the original orientation

When ÚdajeAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.

Additional alignment modes and options introduced in v0.19

Original mode (the default) is the historic alignment mode as in version 0.18. It is not really the Frenet alignment. Original mode uses the normal parameter from Draft.getNormal (or the default) as a constant - it does not calculate curve normal. X follows the curve tangent, Y is the normal parameter, Z is X.Cross(Y).

Tangent mode is similar to Original, but includes a rotation to align the Base object's X to the TangentVector before placing copies. After the rotation, Tangent behaves the same as Original. In previous versions this rotation would be performed manually before invoking PathArray.

Frenet mode orients the copies to a coordinate system along the path. X is tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this option is applied, the normal parameter from Draft.getNormal is ignored. X follows the curve tangent, Z is the VerticalVector property and Y is X.Cross(Z).

Version 18 cycle chain - Original mode

Align false
Align false

Railway cross ties (sleepers) - Tangent mode + ForceVertical

Align false
Align false

Frenet Mode

Align false
Align false